unit Traps;

{****************************************************************************
*                                                                           *
*    Einige Routinen, die Returncodes von Windows-Funktionen auswerten.     *
*    (Hauptanwendung: "Sicherheitsnetz" whrend Programmentwicklung.)       *
*                                                                           *
*    Bei den eventuell angezeigten Fehleradressen ist CS natrlich nur      *
*    beim Lauf unter dem Debugger aussagekrftig; bei Borlands "Find        *
*    Error" mu man stattdessen die laufende Nummer des Segments eingeben.  *
*                                                                           *
****--------------------------------------------------------------------*****
*                                                                           *
*    Compiler: TPWIN 1.5                                                    *
*                                                                           *
****--------------------------------------------------------------------*****
*                                                                           *
*    Rev. 1.0   11.2.92   MK  IR                                            *
*    Rev. 1.1   11.8.92   MK  Einige Meldungstexte verndert                *
*                                                                           *
****************************************************************************}

interface

uses Winprocs, Wintypes;

function TestHandle (TheHandle: THandle): THandle;
procedure TestBool (TheValue: bool);

implementation

{****************************************************************************
*                                                                           *
*                       T e s t H a n d l e                                 *
*                                                                           *
*  AUFGABE: berprft ein Handle;                                           *
*               bricht mit Returncode 10 ab, falls Handle 0                 *
*                                                                           *
*  EINGABE: TheHandle = zu berprfendes Handle                             *
*                                                                           *
*  HINWEIS: Das Programm wird brutal ber HALT gestoppt: kein Aufrumen!    *
*                                                                           *
****************************************************************************}

function TestHandle (TheHandle: THandle): THandle;

var retadr:   array [0..1] of word;
    rcs, rip: word;
    OutText:  array [0..50] of char;

begin
if (TheHandle <> 0) then            { ok }
     TestHandle := TheHandle
   else
     begin
     asm
         mov ax,[bp+4]              { hole Returnadresse }
         mov rcs,ax
         mov ax,[bp+2]
         mov rip,ax
         end;  { asm }
     retadr [0] := rcs;
     retadr [1] := rip-5;           { = Offset des Calls }

     wvsprintf (OutText, 'Handle = 0 at address %X:%X', retadr);
     MessageBox (0, OutText, 'Fatal Error', MB_IconStop or MB_OK);

     halt (10);
     end; { else }

end; { TestHandle }

{****************************************************************************
*                                                                           *
*                       T e s t B o o l                                     *
*                                                                           *
*  AUFGABE: berprft einen logischen Wert;                                 *
*               bricht mit Returncode 11 ab, falls Wert = false             *
*                                                                           *
*  EINGABE: TheValue = zu berprfender logischer Wert                      *
*                                                                           *
*  HINWEIS: Das Programm wird brutal ber HALT gestoppt: kein Aufrumen!    *
*                                                                           *
****************************************************************************}

procedure TestBool (TheValue: bool);

var retadr:   array [0..1] of word;
    rcs, rip: word;
    OutText:  array [0..50] of char;

begin
if (TheValue = false) then
     begin
     asm
         mov ax,[bp+4]              { hole Returnadresse }
         mov rcs,ax
         mov ax,[bp+2]
         mov rip,ax
         end;  { asm }
     retadr [0] := rcs;
     retadr [1] := rip-5;           { = Offset des Calls }

     wvsprintf (OutText, 'API-Function failed at address %X:%X', retadr);
     MessageBox (0, OutText, 'Fatal Error', MB_IconStop or MB_OK);

     halt (11);
     end; { if false }

end; { TestBool }


begin
end.
